package solutions.bitbadger.documents.postgresql

import org.junit.jupiter.api.DisplayName
import solutions.bitbadger.documents.common.Document
import kotlin.test.Test

/**
 * PostgreSQL integration tests for the `Document` object / `insert`, `save`, `update` connection extension functions
 */
@DisplayName("PostgreSQL - Document")
class DocumentIT {

    @Test
    @DisplayName("insert works with default values")
    fun insertDefault() =
        PgDB().use { Document.insertDefault(it.conn) }

    @Test
    @DisplayName("insert fails with duplicate key")
    fun insertDupe() =
        PgDB().use { Document.insertDupe(it.conn) }

    @Test
    @DisplayName("insert succeeds with numeric auto IDs")
    fun insertNumAutoId() =
        PgDB().use { Document.insertNumAutoId(it.conn) }
}
