package solutions.bitbadger.documents.sqlite

import org.junit.jupiter.api.DisplayName
import solutions.bitbadger.documents.common.Custom
import kotlin.test.Test

/**
 * SQLite integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName("SQLite - Custom")
class CustomIT {

    @Test
    @DisplayName("list succeeds with empty list")
    fun listEmpty() =
        SQLiteDB().use { Custom.listEmpty(it.conn) }

    @Test
    @DisplayName("list succeeds with a non-empty list")
    fun listAll() =
        SQLiteDB().use { Custom.listAll(it.conn) }

    @Test
    @DisplayName("single succeeds when document not found")
    fun singleNone() =
        SQLiteDB().use { Custom.singleNone(it.conn) }

    @Test
    @DisplayName("single succeeds when a document is found")
    fun singleOne() =
        SQLiteDB().use { Custom.singleOne(it.conn) }

    @Test
    @DisplayName("nonQuery makes changes")
    fun nonQueryChanges() =
        SQLiteDB().use { Custom.nonQueryChanges(it.conn) }

    @Test
    @DisplayName("nonQuery makes no changes when where clause matches nothing")
    fun nonQueryNoChanges() =
        SQLiteDB().use { Custom.nonQueryNoChanges(it.conn) }

    @Test
    @DisplayName("scalar succeeds")
    fun scalar() =
        SQLiteDB().use { Custom.scalar(it.conn) }
}
