package solutions.bitbadger.documents.sqlite

import solutions.bitbadger.documents.AutoId
import solutions.bitbadger.documents.Configuration
import solutions.bitbadger.documents.TEST_TABLE
import solutions.bitbadger.documents.ensureTable
import java.io.File

/**
 * A wrapper for a throwaway SQLite database
 */
class SQLiteDB : AutoCloseable {

    private var dbName = ""

    init {
        dbName = "test-db-${AutoId.generateRandomString(8)}.db"
        Configuration.connectionString = "jdbc:sqlite:$dbName"
    }

    val conn = Configuration.dbConn()

    init {
        conn.ensureTable(TEST_TABLE)
    }

    override fun close() {
        conn.close()
        File(dbName).delete()
    }

    companion object {

        /** The catalog table for SQLite's schema */
        const val CATALOG = "sqlite_master"
    }
}
